<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 06/25/2004 *
 * ================                             Last change: 06/25/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : nickname_functions.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Nickname functions                               *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Nickname-Funktionen                              *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

//
function NICKNAME_IS_ACTIVE ($uidNick) {
	global $cacheArray;

	// By default nothing is found...
	$ret = false;

	// Found in cache?
	if (isset($cacheArray['nick_active'][$uidNick])) {
		// Use it directly
		$ret = $cacheArray['nick_active'][$uidNick];

		// Increment cache counter
		incrementConfigEntry('cache_hits');
	} else {
		// Search in database
		// @TODO Can we replace this with GET_TOTAL_DATA() ?
		$result = SQL_QUERY_ESC("SELECT userid FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s OR nickname='%s' LIMIT 1",
			array(bigintval($uidNick), $uidNick), __FILE__, __LINE__);

		// Check existence of nickname
		$ret = (SQL_NUMROWS($result) == 1);

		// Put it in cache
		$cacheArray['nick_active'][$uidNick] = $ret;

		// Free result
		SQL_FREERESULT($result);
	}

	// Return nickname
	return $ret;
}

//
function NICKNAME_GET_NICK ($userid) {
	global $cacheArray;

	// If not found...
	$ret = "";

	// Found in cache?
	if (isset($cacheArray['nicknames'][$userid])) {
		// Use it directly
		$ret = $cacheArray['nicknames'][$userid];

		// Increment cache counter
		incrementConfigEntry('cache_hits');
	} elseif (NICKNAME_IS_ACTIVE($userid)) {
		// Search for non-empty nickname
		$result = SQL_QUERY_ESC("SELECT nickname FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s AND nickname != '' LIMIT 1",
			array(bigintval($userid)), __FILE__, __LINE__);

		// Found?
		if (SQL_NUMROWS($result) == 1) {
			// Load nickname from database
			list($ret) = SQL_FETCHROW($result);

			// Put it in cche
			$cacheArray['nicknames'][$userid] = $ret;
		} // END - if

		// Free result
		SQL_FREERESULT($result);
	}

	// Return nickname
	return $ret;
}

// Simple wrapper function
function NICKNAME_PROBE_ON_USERID ($uid) {
	return (NICKNAME_GET_NICK($uid) != "");
}

//
?>
