<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/09/2008 *
 * ===============                              Last change: 09/09/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : load_cache-config.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Load more cache files                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mehr Cache-Dateien nachladen                     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Make cacheInstance global
global $cacheInstance;

// Next cached table is the module registry (mod_reg)...
if (($cacheInstance->loadCacheFile("mod_reg")) && ($cacheInstance->extensionVersionMatches("sql_patches"))) {
	// Load cache
	global $cacheArray;
	$cacheArray['modules'] = $cacheInstance->getArrayFromCache();

	// Rewrite module cache
	$modArray = $cacheArray['modules'];
	foreach ($modArray['module'] as $key => $mod) {
		$cacheArray['modules']['id'][$mod] = $modArray['id'][$key];
		unset($cacheArray['modules']['id'][$key]);
		$cacheArray['modules']['title'][$mod] = $modArray['title'][$key];
		unset($cacheArray['modules']['title'][$key]);
		$cacheArray['modules']['locked'][$mod] = $modArray['locked'][$key];
		unset($cacheArray['modules']['locked'][$key]);
		$cacheArray['modules']['hidden'][$mod] = $modArray['hidden'][$key];
		unset($cacheArray['modules']['hidden'][$key]);
		$cacheArray['modules']['admin_only'][$mod] = $modArray['admin_only'][$key];
		unset($cacheArray['modules']['admin_only'][$key]);
		$cacheArray['modules']['mem_only'][$mod] = $modArray['mem_only'][$key];
		unset($cacheArray['modules']['mem_only'][$key]);
		if (isset($cacheArray['modules']['has_menu'][$key])) {
			$cacheArray['modules']['has_menu'][$mod] = $modArray['has_menu'][$key];
			unset($cacheArray['modules']['has_menu'][$key]);
		} // END - if
	} // END - foreach
	unset($modArray);
} elseif ((getConfig('cache_modreg') == "Y") && ($CSS != "1") && ($CSS != "-1")) {
	// Create cache file here
	$cacheInstance->init("MODULES");
	$cacheInstance->storeExtensionVersion("sql_patches");

	// Load all modules and their data
	if (GET_EXT_VERSION("sql_patches") >= "0.3.6") {
		// Load has_menu
		$result = SQL_QUERY("SELECT id, module, title, locked, hidden, admin_only, title, mem_only, has_menu
FROM `{!_MYSQL_PREFIX!}_mod_reg` ORDER BY `id`", __FILE__, __LINE__);
	} else {
		// Don't load has_menu
		$result = SQL_QUERY("SELECT id, module, title, locked, hidden, admin_only, title, mem_only
FROM `{!_MYSQL_PREFIX!}_mod_reg` ORDER BY `id`", __FILE__, __LINE__);
	}

	// Cache all data
	while ($data = SQL_FETCHARRAY($result)) {
		// Add row to cache file
		$cacheInstance->addRow($data);
	} // END - while

	// Free memory
	SQL_FREERESULT($result);

	// Close the cache
	$cacheInstance->finalize();

	// Reload the cache
	LOAD_INC(__FILE__);
}

//
?>
