<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/15/2003 *
 * ===============                              Last change: 04/02/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-usage.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Auto-detection of usage statistics               *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Automatische Erkennung der Aufrufstatistiken     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

// Base directory (should be moved to database)
$usage = getConfig('usage_base')."/";

if (!empty($_GET['image'])) {
	if ($_GET['type'] == "usage") {
		$FQFN = sprintf("%s%s/usage.png",
			constant('PATH'),
			getConfig('usage_base')
		);
	} else {
		if (strpos($_GET['image'], "\\") > 0) $_GET['image'] = substr($_GET['image'], 0, strpos($_GET['image'], "\\"));
		$FQFN = sprintf("%s%s/%s_usage_%s.png",
			constant('PATH'),
			getConfig('usage_base'),
			SQL_ESCAPE($_GET['type']),
			SQL_ESCAPE($_GET['image'])
		);
	}

	if (FILE_READABLE($FQFN)) {
		$image = imagecreatefrompng($FQFN);
		header("Content-type: image/png");
		imagepng($image);
		imagedestroy($image);
	}
	exit();
} elseif (empty($_GET['usage'])) {
	$FQFN = sprintf("%s%s/index.html",
		constant('PATH'),
		getConfig('usage_base')
	);
} else {
	$FQFN = sprintf("%s%s/usage_%s.html",
		constant('PATH'),
		getConfig('usage_base'),
		SQL_ESCAPE($_GET['usage'])
	);
}

if ((!empty($FQFN)) && (FILE_READABLE($FQFN) {
	// @TODO This code is double, see LOAD_TEMPLATE and LOAD_EMAIL_TEMPLATE in functions.php
	$tmpl_file = READ_FILE($FQFN);
	$tmpl_file = addslashes($tmpl_file);
	$tmpl_file = "\$content=\"".$tmpl_file."\";";
	eval($tmpl_file);
	// Until here...

	// Replace URLs
	$content = str_replace("usage.png", "{!URL!}/modules.php?module=admin&amp;what=".$GLOBALS['what']."&type=usage&image=usage", $content);
	$content = str_replace("daily_usage_", "{!URL!}/modules.php?module=admin&amp;what=".$GLOBALS['what']."&type=daily&image=", $content);
	$content = str_replace("hourly_usage_", "{!URL!}/modules.php?module=admin&amp;what=".$GLOBALS['what']."&type=hourly&image=", $content);
	$content = str_replace("ctry_usage_", "{!URL!}/modules.php?module=admin&amp;what=".$GLOBALS['what']."&type=ctry&image=", $content);
	$content = str_replace("usage_", "{!URL!}/modules.php?module=admin&amp;what=".$GLOBALS['what']."&usage=", str_replace(".html", "", $content));

	// Disabled due to too much trouble
	//$content = str_replace("HREF=\"http://", "href=\"{!URL!}/modules.php?module=loader&amp;url=http://", $content);
	$test = strtolower($content);

	// Do we need to strip out above and including <body> plus trailing </html> tag?
	if ((strpos($test, "<body") > 0) && (strpos($test, "</body>") > 0)) {
		// Okay, then do so.
		$content = substr(substr($content, 0, $body_end), $body_start);
		$content = substr($content, strpos($content, ">") + 1);
	} // END - if

	// Output code
	OUTPUT_HTML("<div align=\"left\">
  ".$content."
</div>");
} else {
	// Nothing to load, then we have no directory "usage"
	LOAD_TEMPLATE("admin_settings_saved", false, sprintf(ADMIN_USAGE_DIRECTORY_404, getConfig('usage_base')));
}

//
?>
